PSyncPointAck Class Reference

This class defines a thread synchronisation object. More...

`#include <syncthrd.h>`

Inheritance diagram for PSyncPointAck:

## Public Member Functions

virtual void | Signal ()
| If there are waiting (blocked) threads then unblock the first one that was blocked. More...
void | Signal (const PTimeInterval &waitTime)
void | Acknowledge ()
| This indicates that the thread that was blocked in a Wait() on this synchronisation object has completed the operation the signal was intended to initiate. More...
Public Member Functions inherited from PSyncPoint
| PSyncPoint ()
| Create a new sync point. More...
| PSyncPoint (const PSyncPoint &)
Public Member Functions inherited from PSemaphore
unsigned | GetInitial () const
unsigned | GetMaxCount () const
| PSemaphore (unsigned initial, unsigned maximum)
| Create a new semaphore with maximum count and initial value specified. More...
| PSemaphore (const PSemaphore &)
| Create a new semaphore with the same initial and maximum values as the original. More...
| ~PSemaphore ()
| Destroy the semaphore. More...
virtual void | Wait ()
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual PBoolean | Wait (const PTimeInterval &timeout)
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual PBoolean | WillBlock () const
| Determine if the semaphore would block if the Wait() function were called. More...
Operations
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

PSyncPoint | ack
Protected Attributes inherited from PSemaphore
unsigned | initialVar
unsigned | maxCountVar
ThreadQueue | waitQueue

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PSemaphore
| PQUEUE (ThreadQueue, PThread)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Detailed Description

This class defines a thread synchronisation object.

This may be used to send signals to a thread and await an acknowldegement that the signal was processed. This can be be used to initiate an action in another thread and wait for the action to be completed.

        ... thread one
        while (condition) {
          sync.Wait();
          do_something();
          sync.Acknowledge();
        }

        ... thread 2
        do_something_else();
        sync.Signal();    // At this point thread 1 wake up and does something.
        do_yet_more();    // However, this does not get done until Acknowledge()
    is called in the other thread.

## Member Function Documentation

## Acknowledge()

void PSyncPointAck::Acknowledge | ( |  | ) |

This indicates that the thread that was blocked in a Wait() on this synchronisation object has completed the operation the signal was intended to initiate.

This unblocks the thread that had called the Signal() function to initiate the action.

## Signal() [1/2]

virtual void PSyncPointAck::Signal | ( |  | ) |

virtual

If there are waiting (blocked) threads then unblock the first one that was blocked.

If no waiting threads and the count is less than the maximum then increment the semaphore.

Unlike the PSyncPoint::Signal() this function will block until the target thread that was blocked by the Wait() function has resumed execution and called the Acknowledge() function.

The `waitTime` parameter is used as a maximum amount of time to wait for the achnowledgement to be returned from the other thread.

Reimplemented from PSemaphore.

## Signal() [2/2]

void PSyncPointAck::Signal | ( | const PTimeInterval & | waitTime | ) |

## Member Data Documentation

## ack

PSyncPoint PSyncPointAck::ack

protected

The documentation for this class was generated from the following file:

- syncthrd.h